%define modname register_digium_products
Summary: Register Digium Products
Name: %{modname}
Version: 4.0.0
Release: 1
License: Proprietary
Group: Applications/Internet
BuildArch: %{_arch}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Source0: register_digium_products.tgz
Epoch: 2009020507

Requires: asterisk >= %{epoch}:11.0
BuildRequires: asterisk-devel >= %{epoch}:11.0
Requires: issabel >= 4.0
Requires: avahi

%description
Asterisk is a complete PBX in software. It runs on Linux and provides
all of the features you would expect from a PBX and more. Asterisk
does voice over IP in three protocols, and can interoperate with
almost all standards-based telephony equipment using relatively
inexpensive hardware.

This module allows you to register for the following products licensed Digium:

Digium Phone Module for Asterisk
G.729 Codec
#Skype For Asterisk

%prep
%setup -n %{modname}

tar -xvzf %{SOURCE0}

%build

#if [ %{_arch} == "x86_64" ] ; then
#     cd setup/64/skypeforasterisk-10.0_1.1.5
#     make ASTLIBDIR=%{_libdir}/asterisk        
#else
#     cd setup/32/skypeforasterisk-10.0_1.1.5
#     make ASTLIBDIR=%{_libdir}/asterisk   
#fi


%install
rm -rf %{buildroot}
rm -rf $RPM_BUILD_ROOT

mkdir -p %{buildroot}%{_libdir}/asterisk/modules/
mkdir -p %{buildroot}%{_localstatedir}/lib/asterisk/licenses
mkdir -p %{buildroot}%{_docdir}
mkdir -p %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_docdir}/asterisk-codec-g729-3.1.5
mkdir -p %{buildroot}%{_docdir}/asterisk-module-dpma-1.6.0
#mkdir -p %{buildroot}%{_docdir}/asterisk-chan-skype-1.1.5
mkdir -p %{buildroot}/usr/share/issabel/privileged/
mkdir -p %{buildroot}%{_sysconfdir}/asterisk/

mkdir -p    %{buildroot}/var/www/html/
mv modules  %{buildroot}/var/www/html/

mkdir -p    %{buildroot}/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
mv menu.xml %{buildroot}/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
#cp setup/certified-asterisk-1.8.11-cert2.tar.gz %{buildroot}/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
#cp setup/certified-asterisk-11.2-cert1.tar.gz %{buildroot}/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/

if [ %{_arch} == "x86_64" ] ; then
     cp setup/registerDigiumProducts %{buildroot}/usr/share/issabel/privileged/
     cp setup/register %{buildroot}%{_sbindir}
     cp -r setup/64/res_digium_phone-11.0_1.6.0 %{buildroot}/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
     cp setup/64/res_digium_phone-11.0_1.6.0/res_digium_phone.so %{buildroot}/usr/lib64/asterisk/modules/
     cp setup/64/res_digium_phone-11.0_1.6.0/res_digium_phone.conf.sample %{buildroot}%{_sysconfdir}/asterisk/res_digium_phone.conf
     cp setup/64/res_digium_phone-11.0_1.6.0/LICENSE %{buildroot}%{_docdir}/asterisk-module-dpma-1.6.0/
     cp setup/64/res_digium_phone-11.0_1.6.0/README %{buildroot}%{_docdir}/asterisk-module-dpma-1.6.0/
     cp setup/64/benchg729 %{buildroot}%{_sbindir}/
     cp setup/64/codec_g729a-11.0_3.1.5-generic/codec_g729a.so %{buildroot}/usr/lib64/asterisk/modules/
     cp setup/64/codec_g729a-11.0_3.1.5-generic/LICENSE %{buildroot}%{_docdir}/asterisk-codec-g729-3.1.5/
     cp setup/64/codec_g729a-11.0_3.1.5-generic/README %{buildroot}%{_docdir}/asterisk-codec-g729-3.1.5/
     #cp setup/LICENSE %{buildroot}%{_docdir}/asterisk-chan-skype-1.1.5/
     #cp setup/README %{buildroot}%{_docdir}/asterisk-chan-skype-1.1.5/
     #cp setup/FAQS %{buildroot}%{_docdir}/asterisk-chan-skype-1.1.5/
     #cd setup/64/skypeforasterisk-10.0_1.1.5/
     #make DESTDIR=%{buildroot} ASTLIBDIR=%{_libdir}/asterisk install
     #make DESTDIR=%{buildroot} ASTLIBDIR=%{_libdir}/asterisk samples
else
     cp setup/registerDigiumProducts %{buildroot}/usr/share/issabel/privileged/
     cp setup/register %{buildroot}%{_sbindir}
     cp -r setup/32/res_digium_phone-11.0_1.6.0 %{buildroot}/usr/share/issabel/module_installer/%{name}-%{version}-%{release}/
     cp setup/32/res_digium_phone-11.0_1.6.0/res_digium_phone.so %{buildroot}%{_libdir}/asterisk/modules/
     cp setup/32/res_digium_phone-11.0_1.6.0/res_digium_phone.conf.sample %{buildroot}%{_sysconfdir}/asterisk/res_digium_phone.conf
     cp setup/32/res_digium_phone-11.0_1.6.0/LICENSE %{buildroot}%{_docdir}/asterisk-module-dpma-1.6.0/
     cp setup/32/res_digium_phone-11.0_1.6.0/README %{buildroot}%{_docdir}/asterisk-module-dpma-1.6.0/
     cp setup/32/benchg729 %{buildroot}%{_sbindir}/
     cp setup/32/codec_g729a-11.0_3.1.5-generic/codec_g729a.so %{buildroot}%{_libdir}/asterisk/modules/
     cp setup/32/codec_g729a-11.0_3.1.5-generic/LICENSE %{buildroot}%{_docdir}/asterisk-codec-g729-3.1.5
     cp setup/32/codec_g729a-11.0_3.1.5-generic/README %{buildroot}%{_docdir}/asterisk-codec-g729-3.1.5
     #cp setup/LICENSE %{buildroot}%{_docdir}/asterisk-chan-skype-1.1.5/
     #cp setup/README %{buildroot}%{_docdir}/asterisk-chan-skype-1.1.5/
     #cp setup/FAQS %{buildroot}%{_docdir}/asterisk-chan-skype-1.1.5/
     #cd setup/32/skypeforasterisk-10.0_1.1.4/
     #make DESTDIR=%{buildroot} ASTLIBDIR=%{_libdir}/asterisk install
     #make DESTDIR=%{buildroot} ASTLIBDIR=%{_libdir}/asterisk samples
fi

# Files provided by all Elastix modules
  
%post
chmod 755 /usr/sbin/register

#se agrega el servicio "avahi-daemon" en el "chkconfig" y se manda a prender el servicio 
/sbin/chkconfig --add avahi-daemon
/sbin/chkconfig --level 235 avahi-daemon on

# Run installer script to fix up ACLs and add module to Elastix menus.
issabel-menumerge /usr/share/issabel/module_installer/%{name}-%{version}-%{release}/menu.xml

# cargamos o recargamos los modulos "res_digium_phone.so" y "codec_g729a.so", si es necesario.
dpma=`asterisk -rx "module show like res_digium_phone" | grep "1 modules loaded" `
g729a=`asterisk -rx "module show like codec_g729a" | grep "1 modules loaded" `

if [ "$dpma" != "" ] ; then
  asterisk -rx "module reload res_digium_phone.so"
else
  asterisk -rx "module load res_digium_phone.so"
fi

if [ "$g729a" != "" ] ; then
  asterisk -rx "module reload codec_g729a.so"
else
  asterisk -rx "module load codec_g729a.so"
fi

service avahi-daemon restart

%preun
# Remove the register.dpma line from /etc/sudoers
if [ $1 -eq 0 ]; then
	echo "Delete Register Digium Product menu"
	issabel-menuremove "%{modname}"
        
        # damos de al modulo "res_digium_phone.so" antes de desinstalarlos.
	dpma=`asterisk -rx "module show like res_digium_phone" | grep "1 modules loaded" `
        
	if [ "$dpma" != "" ] ; then
	  asterisk -rx "module unload res_digium_phone.so"
	fi

        #g729a=`asterisk -rx "module show like codec_g729a" | grep "1 modules loaded" `
        #if [ "$g729a" != "" ] ; then
	#  echo 'unload 729'
	#  asterisk -rx "module unload codec_g729a.so"
	#fi

        #stop service "avahi-daemon" for uninstall
        /sbin/chkconfig avahi-daemon off
        /etc/init.d/avahi-daemon stop
        /sbin/chkconfig --del avahi-daemon
fi
exit 0

%postun
#Se reinicia Asterisk para poder dar de baja al módulo codec_g729a.so
/etc/init.d/asterisk restart

%files
%defattr(-,root,root,-)
# %doc README LICENSE
%{_docdir}/asterisk-codec-g729-3.1.5/*
%{_docdir}/asterisk-module-dpma-1.6.0/*
#%{_docdir}/asterisk-chan-skype-1.1.5/*
%{_sbindir}/register
%{_libdir}/asterisk/modules/res_digium_phone.so
%{_libdir}/asterisk/modules/codec_g729a.so
%{_localstatedir}/lib/asterisk/licenses
#%{_sysconfdir}/asterisk/chan_skype.conf
#%{_libdir}/asterisk/modules/chan_skype.so
#%{_libdir}/asterisk/modules/res_skypeforasterisk.so
/usr/sbin/benchg729
/usr/share/issabel/privileged/registerDigiumProducts
%defattr(-, asterisk, asterisk)
%{_localstatedir}/www/html/modules/register_license_g729/*
%{_localstatedir}/www/html/modules/register_license_dpma
%{_sysconfdir}/asterisk/res_digium_phone.conf
/usr/share/issabel/module_installer/*

%changelog
* Thu Sep 27 2013 Sergio Broncano <sbroncano@palosanto.com> 2.4.0-4
- Added Variable epoch to the header of the spec to solve the dragged 
  dependency of asterisk 11 .
- Added section postun, for to reboot asterisk
- Added service "avahi-daemon" restart 
- Added "avahi-daemon" inside chkconfig

* Thu Sep 20 2013 Sergio Broncano <sbroncano@palosanto.com> 2.4.0-3
- Removed the module skype
- Fixed DPMA registration module

* Thu Jul 18 2013 Luis Abarca <labarca@palosanto.com> 2.4.0-2
- Removed until new order the module dpma

* Fri Jul 03 2012 Sergio Broncano Delgado <sbroncano@palosanto.com> 2.4.0-1
- Initial release
